#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# vim: tabstop=4 expandtab shiftwidth=4 softtabstop=4
# vim: set fileencoding=utf-8
import lxml.etree as etree
import pyagentx


class EntPhysicalEntry(pyagentx.Updater):
    def update(self):
        self.set_OCTETSTRING('2.1', systemnode[0].findtext('description'))
        self.set_OCTETSTRING('7.1', systemnode[0].findtext('product'))
        self.set_OCTETSTRING('11.1', systemnode[0].findtext('serial'))
        self.set_OCTETSTRING('2.2', memorynode[0].findtext('description') + '  ' + memorynode[0].findtext('size'))
        self.set_OCTETSTRING('2.3', cpunode[0].findtext('description'))
        self.set_OCTETSTRING('7.3', cpunode[0].findtext('product'))


class MyAgent(pyagentx.Agent):
    def setup(self):
        self.register('1.3.6.1.2.1.47.1.1.1.1', EntPhysicalEntry)


doc = etree.parse('/var/opt/lshw.xml')
systemnode = doc.xpath('//node[@class="system"]')
memorynode = doc.xpath('//node[@class="memory" and @id="memory"]')
numberOfCpuNodes = len(doc.xpath('//node[@class="processor" and @id="cpu:0"]'))
if 1 == numberOfCpuNodes:
    cpunode = doc.xpath('//node[@class="processor" and @id="cpu:0"]')
else:
    cpunode = doc.xpath('//node[@class="processor" and @id="cpu"]')

try:
    a = MyAgent()
    a.start()
except:
    a.stop()
